// IPCamDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ipcam.h"
#include "IPCamDlg.h"
#include "mmsystem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIPCamDlg dialog


CIPCamDlg::CIPCamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIPCamDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIPCamDlg)
	m_chkLan = FALSE;
	m_bShowFPS = FALSE;
	m_bShowOSDName = FALSE;
	m_bShowOSDTime = FALSE;
	m_bShowRate = FALSE;
	m_bShowStatus = FALSE;
	m_bShowTitle = FALSE;
	m_bShowToolbar = FALSE;
	m_szAcc = _T("");
	m_szID = _T("");
	m_szPwd = _T("");
	m_bTurnImg = FALSE;
	//}}AFX_DATA_INIT
}


void CIPCamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIPCamDlg)
	DDX_Control(pDX, IDC_AXREMOTE, m_Remote);
	DDX_Check(pDX, IDCHK_LAN, m_chkLan);
	DDX_Check(pDX, IDCHK_SHOWFPS, m_bShowFPS);
	DDX_Check(pDX, IDCHK_SHOWOSDNAME, m_bShowOSDName);
	DDX_Check(pDX, IDCHK_SHOWOSDTIME, m_bShowOSDTime);
	DDX_Check(pDX, IDCHK_SHOWRATE, m_bShowRate);
	DDX_Check(pDX, IDCHK_SHOWSTATUS, m_bShowStatus);
	DDX_Check(pDX, IDCHK_SHOWTITLE, m_bShowTitle);
	DDX_Check(pDX, IDCHK_SHOWTOOLBAR, m_bShowToolbar);
	DDX_Text(pDX, IDED_ACC, m_szAcc);
	DDX_Text(pDX, IDED_ID, m_szID);
	DDX_Text(pDX, IDED_PWD, m_szPwd);
	DDX_Check(pDX, IDCHK_TURNIMG, m_bTurnImg);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIPCamDlg, CDialog)
	//{{AFX_MSG_MAP(CIPCamDlg)
	ON_BN_CLICKED(IDCHK_SHOWFPS, OnShowfps)
	ON_BN_CLICKED(IDCHK_SHOWOSDNAME, OnShowosdname)
	ON_BN_CLICKED(IDCHK_SHOWOSDTIME, OnShowosdtime)
	ON_BN_CLICKED(IDCHK_SHOWRATE, OnShowrate)
	ON_BN_CLICKED(IDCHK_SHOWSTATUS, OnShowstatus)
	ON_BN_CLICKED(IDCHK_SHOWTITLE, OnShowtitle)
	ON_BN_CLICKED(IDCHK_SHOWTOOLBAR, OnShowtoolbar)
	ON_BN_CLICKED(IDB_CONNECT, OnConnect)
	ON_BN_CLICKED(IDB_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDB_DEVSET, OnDevset)
	ON_BN_CLICKED(IDB_STARTREC, OnStartrec)
	ON_BN_CLICKED(IDB_STOPREC, OnStoprec)
	ON_BN_CLICKED(IDB_CAPTURE, OnCapture)
	ON_BN_CLICKED(IDB_CAPTURETOOL, OnCapturetool)
	ON_BN_CLICKED(IDB_NETSET, OnNetset)
	ON_BN_CLICKED(IDCHK_TURNIMG, OnTurnimg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIPCamDlg message handlers

BOOL CIPCamDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	
	m_bShowFPS = m_Remote.GetShowFPS();
	m_bShowOSDName = m_Remote.GetShowOSDName();
	m_bShowOSDTime = m_Remote.GetShowOSDTime();
	m_bShowRate = m_Remote.GetShowRate();
	m_bShowStatus = m_Remote.GetShowStatus();
	m_bShowTitle = m_Remote.GetShowTitle();
	m_bShowToolbar = m_Remote.GetShowToolBar();
	
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CIPCamDlg::OnOK() 
{

}


void CIPCamDlg::OnShowfps() 
{
	UpdateData();
	m_Remote.SetShowFPS(m_bShowFPS);
	
}

void CIPCamDlg::OnShowosdname() 
{
	UpdateData();
	m_Remote.SetShowOSDName(m_bShowOSDName);
}

void CIPCamDlg::OnShowosdtime() 
{
	UpdateData();
	m_Remote.SetShowOSDTime(m_bShowOSDTime);	
}

void CIPCamDlg::OnShowrate() 
{
	UpdateData();
	m_Remote.SetShowRate(m_bShowRate);	
}

void CIPCamDlg::OnShowstatus() 
{
	UpdateData();
	m_Remote.SetShowStatus(m_bShowStatus);
}

void CIPCamDlg::OnShowtitle() 
{
	UpdateData();
	m_Remote.SetShowTitle(m_bShowTitle);	
}

void CIPCamDlg::OnShowtoolbar() 
{
	UpdateData();
	m_Remote.SetShowToolBar(m_bShowToolbar);	
}

void CIPCamDlg::OnConnect() 
{
	UpdateData();
	int	nLan;
	if(m_chkLan)
		nLan = 1;
	else
		nLan = 0;
    m_Remote.AddDev4(918,nLan,m_szID,0,"Camera",m_szAcc,m_szPwd,1);
    m_Remote.ConnectAll();	
}

void CIPCamDlg::OnDisconnect() 
{
	m_Remote.DisConnectAll();	
}

void CIPCamDlg::OnDevset() 
{
	m_Remote.DevSet();	
}

void CIPCamDlg::OnStartrec() 
{
    if(m_Remote.GetIsRecing() != 0)
        return;
	int nRe = m_Remote.StartRec("c:\\a.avi");
	//if(nRe != 0)
		 //AfxMessageBox("¼:" + CString(nRe));
	//else
		 //AfxMessageBox("¼ļ c:\\a.avi");	
}

void CIPCamDlg::OnStoprec() 
{
    if(m_Remote.GetIsRecing() != 0)
        m_Remote.StopRec();	
}

void CIPCamDlg::OnCapture() 
{
	int nRe = m_Remote.Capture("c:\\a.bmp");
	//if(nRe != 0)
	//	 AfxMessageBox("ץͼ:" + CString(nRe));
	//else
	//	 AfxMessageBox("ͼƬ c:\\a.bmp");
	
}

void CIPCamDlg::OnCapturetool() 
{
	m_Remote.CaptureTool();	
}

void CIPCamDlg::OnNetset() 
{
	m_Remote.NetSet();	
}

void CIPCamDlg::OnTurnimg() 
{
	UpdateData();
	m_Remote.SetTurnImg(m_bTurnImg);	
}

BEGIN_EVENTSINK_MAP(CIPCamDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CIPCamDlg)
	ON_EVENT(CIPCamDlg, IDC_AXREMOTE, 213 /* OnVideoConnected */, OnOnVideoConnectedAxremote, VTS_I4 VTS_I4)
	ON_EVENT(CIPCamDlg, IDC_AXREMOTE, 214 /* OnVideoDisconnect */, OnOnVideoDisconnectAxremote, VTS_NONE)
	ON_EVENT(CIPCamDlg, IDC_AXREMOTE, 212 /* OnVideoSample */, OnOnVideoSampleAxremote, VTS_I4 VTS_I4 VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


void CIPCamDlg::OnOnVideoConnectedAxremote(long BmpInfo, long AudioFmt) 
{
	BITMAPINFOHEADER	bmpInfo;
	WAVEFORMATEX		aut;

	bmpInfo = *(PBITMAPINFOHEADER)BmpInfo;
	aut = *(PWAVEFORMATEX)AudioFmt;	
}

void CIPCamDlg::OnOnVideoDisconnectAxremote() 
{
	// TODO: Add your control notification handler code here
	
}

void CIPCamDlg::OnOnVideoSampleAxremote(long nFrameID, long IsVideo, long pData, long nDataLen) 
{
/*	
	if(IsVideo == 1){
		PBYTE	p;

		p = PBYTE(pData);

		FILE	*f;
		
		f = fopen("f:\\a.dat","wb");
		fwrite(p,nDataLen,1,f);
		fclose(f);
	}
	*/
}
